/*
 * helper_functions.hpp
 *
 *  Created on: Aug 23, 2017
 *      Author: julien
 */

#ifndef SRC_MODULES_HELPER_FUNCTIONS_HELPER_FUNCTIONS_HPP_
#define SRC_MODULES_HELPER_FUNCTIONS_HELPER_FUNCTIONS_HPP_


#include "../../OpenCV_includes.hpp"
#include "../Function/Function.hpp"


void draw_pointcollection(cv::Mat* src, std::vector<std::vector<cv::Point>>* pointcollection);
void draw_points(cv::Mat* src, std::vector<cv::Point>* points, cv::Scalar color);
void draw_points(cv::Mat* src, std::vector<cv::Point>* points_l, cv::Scalar color_l,
				 std::vector<cv::Point>* points_r, cv::Scalar color_r);


void draw_lane_points(cv::Mat* src, std::vector<std::vector<std::vector<cv::Point>>>* contours);


void print_Mat_info(cv::Mat a);
void print_vector_vector(std::vector<std::vector<cv::Point>> vec);


void to_pPointsvector(std::vector<std::vector<cv::Point>>* src, std::vector<std::vector<Function::pPoint>>* out);
void to_pPoints(std::vector<cv::Point>* src, std::vector<Function::pPoint>* out);
void to_pPoints(std::vector<cv::Point>* src_l, std::vector<Function::pPoint>* out_l,
				std::vector<cv::Point>* src_r, std::vector<Function::pPoint>* out_r);


void to_Pointsvector(std::vector<std::vector<Function::pPoint>>* src, std::vector<std::vector<cv::Point>>* out);
void to_Points(std::vector<Function::pPoint>* src, std::vector<cv::Point>* out);
void to_Points(std::vector<Function::pPoint>* src_l, std::vector<cv::Point>* out_l,
			   std::vector<Function::pPoint>* src_r, std::vector<cv::Point>* out_r);


template <typename T>
void print_vector(std::vector<T> vec, cv::String identifier){
	for(unsigned int i = 0; i < vec.size(); i++){
			std::cout << identifier << " " << i << " : " << vec.at(i) << std::endl;
		}
}

void print_Mat(cv::Mat M, cv::String identifier);


#endif /* SRC_MODULES_HELPER_FUNCTIONS_HELPER_FUNCTIONS_HPP_ */
